import { defineComponent, resolveComponent, openBlock, createBlock, withCtx, createVNode, createElementVNode, unref } from "vue";
import { ElMessage } from "element-plus";
import { I as InlineSvg, R as copySvgPath, o as EventBus } from "./kit-9e2091b1.js";
import { e as edit } from "./edit-949dd013.js";
import { d as deleteSvgPath } from "./index-61273cea.js";
import { _ as _sfc_main$1 } from "./index.vue_vue_type_script_setup_true_lang-88d3fd7d.js";
import { c as copyNode } from "./copy-node-44bf0c2f.js";
import { d as deleteNode } from "./delete-node-731bb9cb.js";
import "./yjs-b5992b64.js";
import "./lib-05b36121.js";
const __default__ = defineComponent({
  name: "menus-count-down-bubble"
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: {
    editor: null
  },
  setup(__props) {
    const props = __props;
    const onEdit = () => {
      new EventBus().emit("edit-count-down");
    };
    const shouldShow = () => {
      var _a;
      return (_a = props.editor) == null ? void 0 : _a.isActive("countdown");
    };
    const copyMe = () => {
      copyNode("countdown", props.editor, () => {
        ElMessage({
          showClose: false,
          message: "复制成功！",
          type: "success"
        });
      });
    };
    const deleteMe = () => {
      deleteNode("countdown", props.editor);
    };
    return (_ctx, _cache) => {
      const _component_el_tooltip = resolveComponent("el-tooltip");
      const _component_el_divider = resolveComponent("el-divider");
      const _component_el_space = resolveComponent("el-space");
      return openBlock(), createBlock(_sfc_main$1, {
        class: "bubble-menu",
        editor: __props.editor,
        "should-show": shouldShow,
        "plugin-key": "count-donw-bubble-menu",
        "tippy-options": { maxWidth: "calc(100vw - 100px)" }
      }, {
        default: withCtx(() => [
          createVNode(_component_el_space, null, {
            default: withCtx(() => [
              createVNode(_component_el_tooltip, {
                content: "复制",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: copyMe
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(copySvgPath)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              }),
              createVNode(_component_el_tooltip, {
                content: "编辑",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: onEdit
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(edit)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              }),
              createVNode(_component_el_divider, {
                class: "h-18px",
                direction: "vertical"
              }),
              createVNode(_component_el_tooltip, {
                content: "删除节点",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: deleteMe
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(deleteSvgPath)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["editor", "tippy-options"]);
    };
  }
});
export {
  _sfc_main as default
};
