import { defineComponent, ref, resolveComponent, openBlock, createBlock, withCtx, createVNode, createElementVNode, unref, withModifiers, createTextVNode } from "vue";
import { ElMessage } from "element-plus";
import { W as getEditorContainerDOMSize, I as InlineSvg, R as copySvgPath, o as EventBus } from "./kit-9e2091b1.js";
import { e as edit } from "./edit-949dd013.js";
import { d as deleteSvgPath } from "./index-61273cea.js";
import { e as externalOpen } from "./external_open-7b39275d.js";
import { l as lineHeightSvgPath } from "./line_height-2f480cdc.js";
import { _ as _sfc_main$1 } from "./index.vue_vue_type_script_setup_true_lang-88d3fd7d.js";
import { c as copyNode } from "./copy-node-44bf0c2f.js";
import { d as deleteNode } from "./delete-node-731bb9cb.js";
import "./yjs-b5992b64.js";
import "./lib-05b36121.js";
const _hoisted_1 = { class: "flex items-center mb-15px" };
const _hoisted_2 = { class: "flex items-center mb-15px" };
const __default__ = defineComponent({
  name: "menus-iframe-bubble"
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: {
    editor: null
  },
  setup(__props) {
    const props = __props;
    const { width: maxWidth } = getEditorContainerDOMSize(props.editor);
    const width = ref(0);
    const height = ref(0);
    const popoverShow = ref(false);
    const onEdit = () => {
      new EventBus().emit("edit-iframe");
    };
    const visitLink = () => {
      const { url } = props.editor.getAttributes("iframe");
      window.open(url, "_blank");
    };
    const openPopover = (value) => {
      setTimeout(() => {
      }, 50);
    };
    const updateSize = () => {
      props.editor.chain().updateAttributes("iframe", {
        width: width.value,
        height: height.value
      }).setNodeSelection(props.editor.state.selection.from).focus().run();
    };
    const shouldShow = () => {
      var _a;
      return (_a = props.editor) == null ? void 0 : _a.isActive("iframe");
    };
    const copyMe = () => {
      copyNode("iframe", props.editor, () => {
        ElMessage({
          showClose: false,
          message: "复制成功！",
          type: "success"
        });
      });
    };
    const deleteMe = () => {
      deleteNode("iframe", props.editor);
    };
    return (_ctx, _cache) => {
      const _component_el_tooltip = resolveComponent("el-tooltip");
      const _component_el_input_number = resolveComponent("el-input-number");
      const _component_el_popover = resolveComponent("el-popover");
      const _component_el_divider = resolveComponent("el-divider");
      const _component_el_space = resolveComponent("el-space");
      return openBlock(), createBlock(_sfc_main$1, {
        class: "bubble-menu",
        editor: __props.editor,
        "should-show": shouldShow,
        "plugin-key": "count-iframe-menu",
        "tippy-options": { maxWidth: "calc(100vw - 100px)" }
      }, {
        default: withCtx(() => [
          createVNode(_component_el_space, null, {
            default: withCtx(() => [
              createVNode(_component_el_tooltip, {
                content: "复制",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: copyMe
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(copySvgPath)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              }),
              createVNode(_component_el_tooltip, {
                content: "访问链接",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: visitLink
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(externalOpen)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              }),
              createVNode(_component_el_tooltip, {
                content: "编辑",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: onEdit
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(edit)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              }),
              createVNode(_component_el_popover, {
                visible: popoverShow.value,
                "onUpdate:visible": _cache[3] || (_cache[3] = ($event) => popoverShow.value = $event),
                placement: "bottom",
                transition: "none",
                "hide-after": 0,
                trigger: "click",
                width: 236
              }, {
                reference: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: _cache[0] || (_cache[0] = withModifiers(($event) => openPopover(popoverShow.value), ["stop"]))
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(lineHeightSvgPath)
                    }, null, 8, ["src"])
                  ])
                ]),
                default: withCtx(() => [
                  createElementVNode("div", _hoisted_1, [
                    createTextVNode(" 宽： "),
                    createVNode(_component_el_input_number, {
                      class: "flex-1",
                      modelValue: width.value,
                      "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => width.value = $event),
                      min: 1,
                      max: unref(maxWidth)
                    }, null, 8, ["modelValue", "max"])
                  ]),
                  createElementVNode("div", _hoisted_2, [
                    createTextVNode(" 高： "),
                    createVNode(_component_el_input_number, {
                      class: "flex-1",
                      modelValue: height.value,
                      "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => height.value = $event),
                      min: 1,
                      max: 9999
                    }, null, 8, ["modelValue"])
                  ]),
                  createElementVNode("div", { class: "flex justify-end" }, [
                    createElementVNode("button", {
                      class: "btn btn-sm btn-primary !py-8px",
                      onClick: updateSize
                    }, "设 置")
                  ])
                ]),
                _: 1
              }, 8, ["visible"]),
              createVNode(_component_el_divider, {
                class: "h-18px",
                direction: "vertical"
              }),
              createVNode(_component_el_tooltip, {
                content: "删除节点",
                effect: "dark",
                placement: "top",
                enterable: false,
                offset: 5,
                "hide-after": 0,
                transition: "none"
              }, {
                default: withCtx(() => [
                  createElementVNode("button", {
                    class: "tiptap-button bg-hover-secondary",
                    onClick: deleteMe
                  }, [
                    createVNode(unref(InlineSvg), {
                      class: "w-17px h-17px",
                      src: unref(deleteSvgPath)
                    }, null, 8, ["src"])
                  ])
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["editor", "tippy-options"]);
    };
  }
});
export {
  _sfc_main as default
};
