import { defineComponent, ref, resolveComponent, openBlock, createBlock, withCtx, createVNode, createTextVNode, unref, createElementVNode, isRef } from "vue";
import { o as EventBus } from "./kit-9e2091b1.js";
import { u as useForm, a as useField, c as create$6, E as ErrorMessage } from "./vee-validate.esm-94488b85.js";
import "element-plus";
const _hoisted_1 = { class: "pb-3" };
const _hoisted_2 = { class: "flex items-center" };
const _hoisted_3 = /* @__PURE__ */ createElementVNode("label", { class: "fw600 fs15 w-80px" }, "标题", -1);
const _hoisted_4 = { class: "mt-5 flex items-center" };
const _hoisted_5 = /* @__PURE__ */ createElementVNode("label", { class: "fw600 fs15 w-80px" }, "截止时间", -1);
const __default__ = defineComponent({
  name: "tiptap-menus-count-down"
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: {
    editor: null
  },
  setup(__props) {
    const props = __props;
    const isEdit = ref(false);
    const isVisible = ref(false);
    const { handleSubmit, isSubmitting, resetForm } = useForm({
      initialValues: {
        title: "倒计时⏰",
        date: new Date((/* @__PURE__ */ new Date()).getTime() + 60 * 60 * 1e3)
      }
    });
    const { value: title, setValue: setTitle } = useField("title", create$6().required("请输入标题！"));
    const { value: date, setValue: setDate } = useField("date", (value) => {
      if (!value)
        return "请选择截止时间！";
      return true;
    });
    new EventBus().on("create-count-down", () => {
      isVisible.value = true;
    });
    new EventBus().on("edit-count-down", () => {
      const view = props.editor.view;
      const slice = view.state.selection.content();
      const { attrs } = slice.content.content[0];
      setTitle(attrs.title);
      setDate(new Date(attrs.date));
      isEdit.value = true;
      isVisible.value = true;
    });
    const onSubmit = handleSubmit((values) => {
      props.editor.chain().focus().setCountDown({ title: values.title, date: values.date.getTime() }).run();
      isVisible.value = false;
    });
    const onReset = () => {
      var _a;
      (_a = props.editor) == null ? void 0 : _a.chain().focus();
      isEdit.value = false;
      resetForm();
    };
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      const _component_el_date_picker = resolveComponent("el-date-picker");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_dialog = resolveComponent("el-dialog");
      return openBlock(), createBlock(_component_el_dialog, {
        modelValue: isVisible.value,
        "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => isVisible.value = $event),
        title: `${isEdit.value ? "编辑" : "插入"}倒计时`,
        width: "448px",
        "align-center": "",
        onClosed: onReset
      }, {
        footer: withCtx(() => [
          createVNode(_component_el_button, {
            onClick: _cache[2] || (_cache[2] = ($event) => isVisible.value = false)
          }, {
            default: withCtx(() => [
              createTextVNode("取 消")
            ]),
            _: 1
          }),
          createVNode(_component_el_button, {
            disabled: unref(isSubmitting),
            loading: unref(isSubmitting),
            type: "primary",
            onClick: unref(onSubmit)
          }, {
            default: withCtx(() => [
              createTextVNode(" 确 认 ")
            ]),
            _: 1
          }, 8, ["disabled", "loading", "onClick"])
        ]),
        default: withCtx(() => [
          createElementVNode("div", _hoisted_1, [
            createElementVNode("div", _hoisted_2, [
              _hoisted_3,
              createVNode(_component_el_input, {
                class: "flex-1",
                size: "large",
                modelValue: unref(title),
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => isRef(title) ? title.value = $event : null),
                placeholder: "请输入标题"
              }, null, 8, ["modelValue"])
            ]),
            createVNode(unref(ErrorMessage), {
              class: "mt-2 ml-80px text-danger",
              name: "title",
              as: "div"
            }),
            createElementVNode("div", _hoisted_4, [
              _hoisted_5,
              createVNode(_component_el_date_picker, {
                class: "flex-1",
                modelValue: unref(date),
                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => isRef(date) ? date.value = $event : null),
                type: "datetime",
                size: "large",
                placeholder: "请选择截止时间",
                shortcuts: [
                  { title: "一小时后", time: 3600 * 1e3 },
                  { title: "明天", time: 3600 * 1e3 * 24 },
                  { title: "一周后", time: 3600 * 1e3 * 24 * 7 }
                ].map(({ title: title2, time }) => {
                  return {
                    text: title2,
                    value: () => {
                      const date2 = /* @__PURE__ */ new Date();
                      date2.setTime(date2.getTime() + time);
                      return date2;
                    }
                  };
                })
              }, null, 8, ["modelValue", "shortcuts"])
            ]),
            createVNode(unref(ErrorMessage), {
              class: "mt-2 ml-80px text-danger",
              name: "date",
              as: "div"
            })
          ])
        ]),
        _: 1
      }, 8, ["modelValue", "title"]);
    };
  }
});
export {
  _sfc_main as default
};
