import { openBlock, createElementBlock, createElementVNode, defineComponent, ref, resolveComponent, resolveDirective, Fragment, createVNode, withModifiers, withCtx, unref, createTextVNode, renderList, toDisplayString, normalizeClass, withDirectives, createCommentVNode, createBlock } from "vue";
import { _ as _sfc_main$2 } from "./index.vue_vue_type_script_setup_true_lang-88d3fd7d.js";
import { $ as katex } from "./kit-9e2091b1.js";
import "element-plus";
/*! Element Plus Icons Vue v2.1.0 */
var export_helper_default = (sfc, props) => {
  let target = sfc.__vccOpts || sfc;
  for (let [key, val] of props)
    target[key] = val;
  return target;
};
var info_filled_vue_vue_type_script_lang_default = {
  name: "InfoFilled"
};
var _hoisted_1143 = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 1024 1024"
}, _hoisted_2143 = /* @__PURE__ */ createElementVNode(
  "path",
  {
    fill: "currentColor",
    d: "M512 64a448 448 0 1 1 0 896.064A448 448 0 0 1 512 64zm67.2 275.072c33.28 0 60.288-23.104 60.288-57.344s-27.072-57.344-60.288-57.344c-33.28 0-60.16 23.104-60.16 57.344s26.88 57.344 60.16 57.344zM590.912 699.2c0-6.848 2.368-24.64 1.024-34.752l-52.608 60.544c-10.88 11.456-24.512 19.392-30.912 17.28a12.992 12.992 0 0 1-8.256-14.72l87.68-276.992c7.168-35.136-12.544-67.2-54.336-71.296-44.096 0-108.992 44.736-148.48 101.504 0 6.784-1.28 23.68.064 33.792l52.544-60.608c10.88-11.328 23.552-19.328 29.952-17.152a12.8 12.8 0 0 1 7.808 16.128L388.48 728.576c-10.048 32.256 8.96 63.872 55.04 71.04 67.84 0 107.904-43.648 147.456-100.416z"
  },
  null,
  -1
  /* HOISTED */
), _hoisted_3142 = [
  _hoisted_2143
];
function _sfc_render143(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("svg", _hoisted_1143, _hoisted_3142);
}
var info_filled_default = /* @__PURE__ */ export_helper_default(info_filled_vue_vue_type_script_lang_default, [["render", _sfc_render143], ["__file", "info-filled.vue"]]);
var findEndOfMath = function findEndOfMath2(delimiter, text, startIndex) {
  var index = startIndex;
  var braceLevel = 0;
  var delimLength = delimiter.length;
  while (index < text.length) {
    var character = text[index];
    if (braceLevel <= 0 && text.slice(index, index + delimLength) === delimiter) {
      return index;
    } else if (character === "\\") {
      index++;
    } else if (character === "{") {
      braceLevel++;
    } else if (character === "}") {
      braceLevel--;
    }
    index++;
  }
  return -1;
};
var escapeRegex = function escapeRegex2(string) {
  return string.replace(/[-/\\^$*+?.()|[\]{}]/g, "\\$&");
};
var amsRegex = /^\\begin{/;
var splitAtDelimiters = function splitAtDelimiters2(text, delimiters) {
  var index;
  var data = [];
  var regexLeft = new RegExp("(" + delimiters.map((x) => escapeRegex(x.left)).join("|") + ")");
  while (true) {
    index = text.search(regexLeft);
    if (index === -1) {
      break;
    }
    if (index > 0) {
      data.push({
        type: "text",
        data: text.slice(0, index)
      });
      text = text.slice(index);
    }
    var i = delimiters.findIndex((delim) => text.startsWith(delim.left));
    index = findEndOfMath(delimiters[i].right, text, delimiters[i].left.length);
    if (index === -1) {
      break;
    }
    var rawData = text.slice(0, index + delimiters[i].right.length);
    var math = amsRegex.test(rawData) ? rawData : text.slice(delimiters[i].left.length, index);
    data.push({
      type: "math",
      data: math,
      rawData,
      display: delimiters[i].display
    });
    text = text.slice(index + delimiters[i].right.length);
  }
  if (text !== "") {
    data.push({
      type: "text",
      data: text
    });
  }
  return data;
};
var renderMathInText = function renderMathInText2(text, optionsCopy) {
  var data = splitAtDelimiters(text, optionsCopy.delimiters);
  if (data.length === 1 && data[0].type === "text") {
    return null;
  }
  var fragment = document.createDocumentFragment();
  for (var i = 0; i < data.length; i++) {
    if (data[i].type === "text") {
      fragment.appendChild(document.createTextNode(data[i].data));
    } else {
      var span = document.createElement("span");
      var math = data[i].data;
      optionsCopy.displayMode = data[i].display;
      try {
        if (optionsCopy.preProcess) {
          math = optionsCopy.preProcess(math);
        }
        katex.render(math, span, optionsCopy);
      } catch (e) {
        if (!(e instanceof katex.ParseError)) {
          throw e;
        }
        optionsCopy.errorCallback("KaTeX auto-render: Failed to parse `" + data[i].data + "` with ", e);
        fragment.appendChild(document.createTextNode(data[i].rawData));
        continue;
      }
      fragment.appendChild(span);
    }
  }
  return fragment;
};
var renderElem = function renderElem2(elem, optionsCopy) {
  for (var i = 0; i < elem.childNodes.length; i++) {
    var childNode = elem.childNodes[i];
    if (childNode.nodeType === 3) {
      var textContentConcat = childNode.textContent;
      var sibling = childNode.nextSibling;
      var nSiblings = 0;
      while (sibling && sibling.nodeType === Node.TEXT_NODE) {
        textContentConcat += sibling.textContent;
        sibling = sibling.nextSibling;
        nSiblings++;
      }
      var frag = renderMathInText(textContentConcat, optionsCopy);
      if (frag) {
        for (var j = 0; j < nSiblings; j++) {
          childNode.nextSibling.remove();
        }
        i += frag.childNodes.length - 1;
        elem.replaceChild(frag, childNode);
      } else {
        i += nSiblings;
      }
    } else if (childNode.nodeType === 1) {
      (function() {
        var className = " " + childNode.className + " ";
        var shouldRender = optionsCopy.ignoredTags.indexOf(childNode.nodeName.toLowerCase()) === -1 && optionsCopy.ignoredClasses.every((x) => className.indexOf(" " + x + " ") === -1);
        if (shouldRender) {
          renderElem2(childNode, optionsCopy);
        }
      })();
    }
  }
};
var renderMathInElement = function renderMathInElement2(elem, options) {
  if (!elem) {
    throw new Error("No element provided to render");
  }
  var optionsCopy = {};
  for (var option in options) {
    if (options.hasOwnProperty(option)) {
      optionsCopy[option] = options[option];
    }
  }
  optionsCopy.delimiters = optionsCopy.delimiters || [
    {
      left: "$$",
      right: "$$",
      display: true
    },
    {
      left: "\\(",
      right: "\\)",
      display: false
    },
    // LaTeX uses $…$, but it ruins the display of normal `$` in text:
    // {left: "$", right: "$", display: false},
    // $ must come after $$
    // Render AMS environments even if outside $$…$$ delimiters.
    {
      left: "\\begin{equation}",
      right: "\\end{equation}",
      display: true
    },
    {
      left: "\\begin{align}",
      right: "\\end{align}",
      display: true
    },
    {
      left: "\\begin{alignat}",
      right: "\\end{alignat}",
      display: true
    },
    {
      left: "\\begin{gather}",
      right: "\\end{gather}",
      display: true
    },
    {
      left: "\\begin{CD}",
      right: "\\end{CD}",
      display: true
    },
    {
      left: "\\[",
      right: "\\]",
      display: true
    }
  ];
  optionsCopy.ignoredTags = optionsCopy.ignoredTags || ["script", "noscript", "style", "textarea", "pre", "code", "option"];
  optionsCopy.ignoredClasses = optionsCopy.ignoredClasses || [];
  optionsCopy.errorCallback = optionsCopy.errorCallback || console.error;
  optionsCopy.macros = optionsCopy.macros || {};
  renderElem(elem, optionsCopy);
};
const _hoisted_1 = { class: "p-10px w-344px" };
const _hoisted_2 = { class: "mt-2 flex items-center justify-between" };
const _hoisted_3 = { class: "fs16 px-50px py-10px mh-vh-200 overflow-overlay" };
const _hoisted_4 = /* @__PURE__ */ createElementVNode("p", null, "每个部分的内容是：代码，预览。", -1);
const _hoisted_5 = { class: "fs19 fw600 mt-44px mb-22px text-gray-900" };
const _hoisted_6 = { class: "fs17 fw600 mt-33px mb-22px text-gray-900" };
const __default__$1 = defineComponent({
  name: "tiptap-menus-katex-editor",
  directives: {
    katex: (el, binding) => {
      let options = {
        delimiters: [
          { left: "$$", right: "$$", display: true },
          { left: "$", right: "$", display: false }
        ]
      };
      if (binding.value) {
        options = binding.value;
      }
      el.classList.add("fs16");
      el.style.position = "relative";
      renderMathInElement(el, options);
    }
  }
});
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  ...__default__$1,
  props: {
    editor: null
  },
  setup(__props, { expose }) {
    const props = __props;
    const katexValue = ref("");
    const isVisible = ref(false);
    const content = [
      {
        title: "标记",
        children: [
          {
            title: "导数符号",
            code: [{ content: String.raw`f'(x)` }]
          },
          {
            title: "向量",
            code: [{ content: String.raw`\vec {a}` }, { content: String.raw`\overrightarrow {PP_0}` }]
          },
          {
            title: "帽子",
            code: [{ content: String.raw`\hat{\theta}` }, { content: String.raw`\widehat{ac}` }]
          }
        ]
      },
      {
        title: "分隔符",
        children: [
          {
            title: "小括号",
            code: [{ content: String.raw`(x)` }]
          },
          {
            title: "中括号",
            code: [{ content: String.raw`[x]` }]
          },
          {
            title: "大括号",
            code: [{ content: String.raw`\{x\}` }]
          },
          {
            title: "绝对值",
            code: [{ content: String.raw`|x|` }]
          },
          {
            title: "分隔符大小",
            code: [
              { content: String.raw`( \big( \Big( \bigg( \Bigg(` },
              { content: String.raw`(\csc x)' = \Big ( \frac {1} {\sin x} \Big )'` },
              { content: String.raw`\frac {d^2f} {dx^2} \Bigg | _{x=x_0}` }
            ]
          }
        ]
      },
      {
        title: "环境",
        children: [
          {
            title: "分段函数",
            code: [
              {
                content: String.raw`f(x) = \begin {cases}
x, & \text {if } x \ge 0 \\
-x, & \text {if } x < 0
\end {cases}`
              }
            ]
          },
          {
            title: "V矩阵",
            code: [
              {
                content: String.raw`\begin {vmatrix}
a & b \\
c & d
\end {vmatrix}`
              }
            ]
          }
        ]
      },
      {
        title: "布局",
        children: [
          {
            title: "换行符",
            code: [
              {
                content: String.raw`a b \\ c d`
              }
            ]
          }
        ]
      },
      {
        title: "希腊字母",
        children: [
          {
            title: "alpha",
            code: [
              {
                content: String.raw`\alpha`
              }
            ]
          },
          {
            title: "beta",
            code: [
              {
                content: String.raw`\beta`
              }
            ]
          },
          {
            title: "Delta",
            code: [
              {
                content: String.raw`\Delta`
              }
            ]
          },
          {
            title: "theta",
            code: [
              {
                content: String.raw`\theta`
              }
            ]
          },
          {
            title: "lambda",
            code: [
              {
                content: String.raw`\lambda`
              }
            ]
          },
          {
            title: "mu",
            code: [
              {
                content: String.raw`\mu`
              }
            ]
          },
          {
            title: "xi",
            code: [
              {
                content: `\\xi`
              }
            ]
          },
          {
            title: "pi",
            code: [
              {
                content: String.raw`\pi`
              }
            ]
          },
          {
            title: "partial",
            code: [
              {
                content: String.raw`\partial`
              }
            ]
          }
        ]
      },
      {
        title: "二元运算符",
        children: [
          {
            title: "加",
            code: [{ content: String.raw`x + y` }]
          },
          {
            title: "减",
            code: [{ content: String.raw`x - y` }]
          },
          {
            title: "乘",
            code: [{ content: String.raw`x \times y` }]
          },
          {
            title: "除",
            code: [{ content: String.raw`x \div y` }]
          },
          {
            title: "交",
            code: [{ content: String.raw`(0,5) \cap (-1,3)` }]
          },
          {
            title: "并",
            code: [{ content: String.raw`(-\infty, 0) \cup (0, +\infty)` }]
          }
        ]
      },
      {
        title: "垂直布局",
        children: [
          {
            title: "上标",
            code: [{ content: String.raw`e^x` }]
          },
          {
            title: "下标",
            code: [{ content: String.raw`x_n` }]
          }
        ]
      },
      {
        title: "空格",
        children: [
          {
            title: "",
            code: [{ content: String.raw`a b \\ a \space b` }, { content: String.raw`a b \\ a \ b` }]
          }
        ]
      },
      {
        title: "逻辑与集合论",
        children: [
          {
            title: "属于",
            code: [{ content: String.raw`k \in \bf {Z}` }]
          },
          {
            title: "含于",
            code: [{ content: String.raw`D \subset R` }]
          }
        ]
      },
      {
        title: "大运算符",
        children: [
          {
            title: "积分",
            code: [
              { content: String.raw`\int _{-\infty} ^{+\infty} e^x dx` },
              { content: String.raw`\iint \limits _D f(x,y) dxdy` }
            ]
          },
          {
            title: "和",
            code: [
              { content: String.raw`\sum \limits _{i=1} ^n f(x)` },
              { content: String.raw`\sum \limits _{\substack {0<i<m \\ 0<j<n}} f(x)` }
            ]
          },
          {
            title: "积",
            code: [{ content: String.raw`\prod \limits _{k=1} ^n a_k` }]
          }
        ]
      },
      {
        title: "分数",
        children: [
          {
            title: "",
            code: [{ content: String.raw`\frac {x^2} {x+1}` }, { content: String.raw`\frac {a} {1 + \frac {1} {b}}` }]
          }
        ]
      },
      {
        title: "数学运算符",
        children: [
          {
            title: "sin",
            code: [{ content: String.raw`\sin x` }]
          },
          {
            title: "cos",
            code: [{ content: String.raw`\cos x` }]
          },
          {
            title: "tan",
            code: [{ content: String.raw`\tan x` }]
          },
          {
            title: "arcsin",
            code: [{ content: String.raw`\arcsin x` }]
          },
          {
            title: "arctan",
            code: [{ content: String.raw`\arctan x` }]
          },
          {
            title: "lg",
            code: [{ content: String.raw`\lg x` }]
          },
          {
            title: "ln",
            code: [{ content: String.raw`\ln x` }]
          },
          {
            title: "log",
            code: [{ content: String.raw`\log x` }]
          },
          {
            title: "根号",
            code: [{ content: String.raw`\sqrt x` }, { content: String.raw`\sqrt [3] {x^2+2x+1}` }]
          },
          {
            title: "lim",
            code: [
              {
                content: String.raw`f'(x) = \lim \limits _{\Delta x \rightarrow 0} \frac {f(x + \Delta x) - f(x)} {\Delta x}`
              }
            ]
          }
        ]
      },
      {
        title: "关系",
        children: [
          {
            title: "等于",
            code: [{ content: String.raw`x = y` }]
          },
          {
            title: "不等于",
            code: [{ content: String.raw`x \ne y` }]
          },
          {
            title: "小于",
            code: [{ content: String.raw`x < y` }]
          },
          {
            title: "大于",
            code: [{ content: String.raw`x > y` }]
          },
          {
            title: "小于等于",
            code: [{ content: String.raw`x \le y` }]
          },
          {
            title: "大于等于",
            code: [{ content: String.raw`x \ge y` }]
          },
          {
            title: "全等于",
            code: [{ content: String.raw`F(x,f(x)) \equiv 0, x \in D` }]
          },
          {
            title: "约等于",
            code: [{ content: String.raw`x \approx y` }]
          }
        ]
      },
      {
        title: "箭头",
        children: [
          {
            title: "右箭头",
            code: [{ content: String.raw`x \rightarrow 0` }]
          },
          {
            title: "否右箭头",
            code: [{ content: String.raw`x \nrightarrow 0` }]
          },
          {
            title: "长等于",
            code: [{ content: `2^{\\frac 1 x} \\xlongequal {y = \\frac 1 x} 2^y` }]
          }
        ]
      },
      {
        title: "字体",
        children: [
          {
            title: "粗体",
            code: [{ content: String.raw`R \ \  \bf R` }]
          }
        ]
      },
      {
        title: "符号和标点",
        children: [
          {
            title: "无穷",
            code: [{ content: String.raw`\infty` }]
          },
          {
            title: "省略号",
            code: [{ content: String.raw`\dots` }]
          },
          {
            title: "点乘",
            code: [{ content: String.raw`x \cdot y` }]
          }
        ]
      }
    ];
    const onSubmit = () => {
      props.editor.chain().focus().setKatex({ text: katexValue.value }).run();
    };
    expose({
      init: () => {
        const { text } = props.editor.getAttributes("katex");
        katexValue.value = decodeURIComponent(text ?? "");
      }
    });
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      const _component_el_icon = resolveComponent("el-icon");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_link = resolveComponent("el-link");
      const _component_el_dialog = resolveComponent("el-dialog");
      const _directive_katex = resolveDirective("katex");
      return openBlock(), createElementBlock(Fragment, null, [
        createElementVNode("div", _hoisted_1, [
          createVNode(_component_el_input, {
            class: "rd-4px katex-editor-input",
            modelValue: katexValue.value,
            "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => katexValue.value = $event),
            rows: 4,
            type: "textarea",
            placeholder: "请输入数学公式",
            onMousedown: _cache[1] || (_cache[1] = withModifiers(() => {
            }, ["stop"]))
          }, null, 8, ["modelValue"]),
          createElementVNode("div", _hoisted_2, [
            createElementVNode("span", {
              class: "flex fs14 items-center cursor-pointer text-gray-700",
              onClick: _cache[2] || (_cache[2] = withModifiers(($event) => isVisible.value = true, ["stop"]))
            }, [
              createVNode(_component_el_icon, { class: "fs16! ml-0 mr-1" }, {
                default: withCtx(() => [
                  createVNode(unref(info_filled_default))
                ]),
                _: 1
              }),
              createTextVNode(" 查看帮助文档 ")
            ]),
            createVNode(_component_el_button, {
              type: "primary",
              size: "default",
              onClick: onSubmit
            }, {
              default: withCtx(() => [
                createTextVNode("确定")
              ]),
              _: 1
            })
          ])
        ]),
        createVNode(_component_el_dialog, {
          class: "max-w-98% cursor-auto about-katex-dialog",
          modelValue: isVisible.value,
          "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => isVisible.value = $event),
          title: "数学公式帮助文档",
          width: "960px",
          "append-to-body": "",
          "align-center": "",
          onClick: _cache[4] || (_cache[4] = withModifiers(() => {
          }, ["stop"]))
        }, {
          default: withCtx(() => [
            createElementVNode("div", _hoisted_3, [
              createElementVNode("p", null, [
                createTextVNode(" 这里介绍一些微积分中最常用的基本公式，更多信息请参见 "),
                createVNode(_component_el_link, {
                  href: "https://katex.org/docs/supported.html",
                  target: "_blank",
                  type: "primary"
                }, {
                  default: withCtx(() => [
                    createTextVNode("KaTeX")
                  ]),
                  _: 1
                }),
                createTextVNode(" 。 ")
              ]),
              _hoisted_4,
              (openBlock(), createElementBlock(Fragment, null, renderList(content, (item, index) => {
                return openBlock(), createElementBlock(Fragment, { key: index }, [
                  createElementVNode("h2", _hoisted_5, toDisplayString(index + 1) + ". " + toDisplayString(item.title), 1),
                  item.code ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(item.code, (code, c) => {
                    return openBlock(), createElementBlock(Fragment, { key: c }, [
                      createElementVNode("div", {
                        class: normalizeClass(["highlight", { "pt-40px": c }])
                      }, [
                        createElementVNode("pre", null, [
                          createElementVNode("code", null, toDisplayString(code.content), 1)
                        ])
                      ], 2),
                      withDirectives((openBlock(), createElementBlock("p", null, [
                        createTextVNode("$" + toDisplayString(code.content) + "$", 1)
                      ])), [
                        [_directive_katex]
                      ])
                    ], 64);
                  }), 128)) : createCommentVNode("", true),
                  item.children ? (openBlock(true), createElementBlock(Fragment, { key: 1 }, renderList(item.children, (child, i) => {
                    return openBlock(), createElementBlock(Fragment, { key: i }, [
                      createElementVNode("h3", _hoisted_6, toDisplayString(index + 1) + "." + toDisplayString(i + 1) + ". " + toDisplayString(child.title), 1),
                      child.code ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(child.code, (code, c) => {
                        return openBlock(), createElementBlock(Fragment, { key: c }, [
                          createElementVNode("div", {
                            class: normalizeClass(["highlight", { "pt-40px": c }])
                          }, [
                            createElementVNode("pre", null, [
                              createElementVNode("code", null, toDisplayString(code.content), 1)
                            ])
                          ], 2),
                          withDirectives((openBlock(), createElementBlock("p", null, [
                            createTextVNode("$" + toDisplayString(code.content) + "$", 1)
                          ])), [
                            [_directive_katex]
                          ])
                        ], 64);
                      }), 128)) : createCommentVNode("", true)
                    ], 64);
                  }), 128)) : createCommentVNode("", true)
                ], 64);
              }), 64))
            ])
          ]),
          _: 1
        }, 8, ["modelValue"])
      ], 64);
    };
  }
});
const editor_vue_vue_type_style_index_0_lang = "";
const __default__ = defineComponent({
  name: "tiptap-menus-katex"
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: {
    editor: null
  },
  setup(__props) {
    const props = __props;
    const katexEditorRef = ref(false);
    const shouldShow = () => {
      var _a;
      return (_a = props.editor) == null ? void 0 : _a.isActive("katex");
    };
    const onInit = () => {
      katexEditorRef.value.init();
    };
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$2, {
        class: "bubble-menu",
        editor: __props.editor,
        "should-show": shouldShow,
        "plugin-key": "katex-bubble-menu",
        "tippy-options": {
          maxWidth: "calc(100vw - 100px)",
          placement: "bottom",
          onShow: onInit
        }
      }, {
        default: withCtx(() => [
          createVNode(_sfc_main$1, {
            ref_key: "katexEditorRef",
            ref: katexEditorRef,
            editor: __props.editor
          }, null, 8, ["editor"])
        ]),
        _: 1
      }, 8, ["editor", "tippy-options"]);
    };
  }
});
export {
  _sfc_main as default
};
