import { defineComponent, ref, resolveComponent, openBlock, createBlock, withCtx, createElementVNode, createVNode, createTextVNode, unref, isRef } from "vue";
import { o as EventBus } from "./kit-9e2091b1.js";
import { u as useForm, a as useField, c as create$6, E as ErrorMessage } from "./vee-validate.esm-94488b85.js";
import "element-plus";
const _hoisted_1 = { class: "pb-3" };
const _hoisted_2 = { class: "flex items-center" };
const _hoisted_3 = /* @__PURE__ */ createElementVNode("label", { class: "fw600 fs15 w-50px" }, "链接", -1);
const _hoisted_4 = { class: "flex items-center justify-between" };
const _hoisted_5 = { class: "flex items-center" };
const __default__ = defineComponent({
  name: "tiptap-menus-iframe"
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: {
    editor: null
  },
  setup(__props) {
    const props = __props;
    const isVisible = ref(false);
    const { handleSubmit, isSubmitting, resetForm } = useForm({
      initialValues: {
        url: ""
      }
    });
    const { value: url, setValue: setUrl } = useField("url", create$6().url("请输入正确的链接地址！"));
    new EventBus().on("create-iframe", () => {
      isVisible.value = true;
    });
    new EventBus().on("edit-iframe", () => {
      const view = props.editor.view;
      const slice = view.state.selection.content();
      const { attrs } = slice.content.content[0];
      setUrl(attrs.url ?? "");
      isVisible.value = true;
    });
    const onSubmit = handleSubmit((values) => {
      props.editor.chain().focus().setIframe({ url: values.url }).run();
      isVisible.value = false;
    });
    const onReset = () => {
      var _a;
      (_a = props.editor) == null ? void 0 : _a.chain().focus();
      resetForm();
    };
    return (_ctx, _cache) => {
      const _component_el_input = resolveComponent("el-input");
      const _component_el_button = resolveComponent("el-button");
      const _component_el_dialog = resolveComponent("el-dialog");
      return openBlock(), createBlock(_component_el_dialog, {
        modelValue: isVisible.value,
        "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => isVisible.value = $event),
        title: "编辑链接",
        width: "448px",
        "align-center": "",
        onClosed: onReset
      }, {
        footer: withCtx(() => [
          createElementVNode("div", _hoisted_4, [
            createElementVNode("span", {
              class: "fs14 cursor-pointer text-gray-600",
              onClick: _cache[1] || (_cache[1] = ($event) => url.value = "https://i.y.qq.com/n2/m/outchain/player/index.html?songid=1117059")
            }, " 查看示例 "),
            createElementVNode("div", _hoisted_5, [
              createVNode(_component_el_button, {
                onClick: _cache[2] || (_cache[2] = ($event) => isVisible.value = false)
              }, {
                default: withCtx(() => [
                  createTextVNode("取 消")
                ]),
                _: 1
              }),
              createVNode(_component_el_button, {
                disabled: unref(isSubmitting),
                loading: unref(isSubmitting),
                type: "primary",
                onClick: unref(onSubmit)
              }, {
                default: withCtx(() => [
                  createTextVNode(" 确 认 ")
                ]),
                _: 1
              }, 8, ["disabled", "loading", "onClick"])
            ])
          ])
        ]),
        default: withCtx(() => [
          createElementVNode("div", _hoisted_1, [
            createElementVNode("div", _hoisted_2, [
              _hoisted_3,
              createVNode(_component_el_input, {
                class: "flex-1",
                size: "large",
                modelValue: unref(url),
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => isRef(url) ? url.value = $event : null),
                placeholder: "请输入外链地址"
              }, null, 8, ["modelValue"])
            ]),
            createVNode(unref(ErrorMessage), {
              class: "mt-2 ml-50px text-danger",
              name: "url",
              as: "div"
            })
          ])
        ]),
        _: 1
      }, 8, ["modelValue"]);
    };
  }
});
export {
  _sfc_main as default
};
