import { k as kit, O as generateHTML, Q as generateJSON, u as useEditor$1, E as EditorContent$1 } from "./kit-9e2091b1.js";
import "element-plus";
import "vue";
const extensions = kit({ isExpand: true });
const generateHtml = (json) => {
  return generateHTML(json, extensions);
};
const generateJson = (html) => {
  return generateJSON(html, extensions);
};
const getArrToContent = async (array, isJson) => {
  const { TiptapTransformer } = await import("./hocuspocus-transformer.esm-1089d9dc.js");
  const Y = await import("./yjs-b5992b64.js");
  const yDoc = new Y.Doc();
  Y.applyUpdate(yDoc, new Uint8Array(array));
  const contentJsonFromDoc = TiptapTransformer.fromYdoc(yDoc);
  return isJson ? contentJsonFromDoc.default : generateHtml(contentJsonFromDoc.default);
};
const getContentToArr = async (content) => {
  const { TiptapTransformer } = await import("./hocuspocus-transformer.esm-1089d9dc.js");
  const Y = await import("./yjs-b5992b64.js");
  if (typeof content === "string")
    content = generateJson(content);
  const jsonToDoc = TiptapTransformer.toYdoc(content, void 0, extensions);
  const stateArrayBuffer = Y.encodeStateAsUpdate(jsonToDoc).buffer;
  const stateArray = Array.from(new Uint8Array(stateArrayBuffer));
  return stateArray;
};
const useEditor = useEditor$1;
const EditorContent = EditorContent$1;
export {
  EditorContent,
  extensions,
  generateHtml,
  generateJson,
  getArrToContent,
  getContentToArr,
  useEditor
};
