import * as all from '@tiptap/vue-3';
export type { Editor, JSONContent } from '@tiptap/vue-3';
export declare const extensions: (all.Mark<import("@tiptap/extension-code").CodeOptions, any> | all.Extension<any, any> | all.Node<any, any>)[];
export declare const generateHtml: (json: Record<string, any>) => string;
export declare const generateJson: (html: string) => Record<string, any>;
/**
 * @description: 将 Yjs 内部使用的 Uint8Array 类型数组转换为 JSON 字符串或 HTML 内容
 * @param {number[]} array Yjs 内部使用的 Uint8Array 类型数组，其中每个元素代表一个无符号 8 位整数（范围在0-255之间）
 * @param {boolean} [isJson] 可选参数，指定是否将结果转换为 JSON 格式，默认为 false（即转换为 HTML 格式）
 * @returns {Promise<string | any[]>} 转换后的 JSON 字符串或 HTML 内容
 */
export declare const getArrToContent: (array: number[], isJson?: boolean) => Promise<string | any[]>;
/**
 * @description: 将输入的 JSON 字符串或对象转换为 Yjs 内部使用的 Uint8Array 类型数组
 * @param {string | Record<string, any>} content 输入的 JSON 字符串或对象，字符串类型的 JSON 或者 Record<string, any> 类型的 JSON 对象
 * @returns {Promise<number[]>} Yjs 内部使用的 Uint8Array 类型数组，其中每个元素代表一个无符号 8 位整数（范围在0-255之间）
 */
export declare const getContentToArr: (content: string | Record<string, any>) => Promise<number[]>;
export declare const useEditor: (options?: Partial<all.EditorOptions> | undefined) => import("vue").ShallowRef<all.Editor | undefined>;
export declare const EditorContent: import("vue").DefineComponent<{
    editor: {
        default: null;
        type: import("vue").PropType<all.Editor>;
    };
}, {
    rootEl: import("vue").Ref<Element | undefined>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    editor: {
        default: null;
        type: import("vue").PropType<all.Editor>; /**
         * @description: 将 Yjs 内部使用的 Uint8Array 类型数组转换为 JSON 字符串或 HTML 内容
         * @param {number[]} array Yjs 内部使用的 Uint8Array 类型数组，其中每个元素代表一个无符号 8 位整数（范围在0-255之间）
         * @param {boolean} [isJson] 可选参数，指定是否将结果转换为 JSON 格式，默认为 false（即转换为 HTML 格式）
         * @returns {Promise<string | any[]>} 转换后的 JSON 字符串或 HTML 内容
         */
    };
}>>, {
    editor: all.Editor;
}>;
